
package gov.nasa.gsfc.spdf.ssc.client;

import java.util.ArrayList;
import java.util.List;
import jakarta.xml.bind.annotation.XmlAccessType;
import jakarta.xml.bind.annotation.XmlAccessorType;
import jakarta.xml.bind.annotation.XmlElement;
import jakarta.xml.bind.annotation.XmlSchemaType;
import jakarta.xml.bind.annotation.XmlType;


/**
 * <p>Java class for mapProjectionGraphOptions complex type.
 * 
 * <p>The following schema fragment specifies the expected content contained within this class.
 * 
 * <pre>{@code
 * <complexType name="mapProjectionGraphOptions">
 *   <complexContent>
 *     <extension base="{http://ssc.spdf.gsfc.nasa.gov/}graphOptions">
 *       <sequence>
 *         <element name="coordinateSystem" type="{http://ssc.spdf.gsfc.nasa.gov/}projectionCoordinateSystem" minOccurs="0"/>
 *         <element name="formatOptions" type="{http://ssc.spdf.gsfc.nasa.gov/}graphFormatOptions" minOccurs="0"/>
 *         <element name="groundStations" type="{http://www.w3.org/2001/XMLSchema}string" maxOccurs="unbounded" minOccurs="0"/>
 *         <element name="longitudeVerticalDown" type="{http://www.w3.org/2001/XMLSchema}float"/>
 *         <element name="mapLimits" type="{http://ssc.spdf.gsfc.nasa.gov/}mapLimits" minOccurs="0"/>
 *         <element name="polarMapOrientation" type="{http://ssc.spdf.gsfc.nasa.gov/}polarMapOrientation" minOccurs="0"/>
 *         <element name="projection" type="{http://ssc.spdf.gsfc.nasa.gov/}mapProjection" minOccurs="0"/>
 *         <element name="showContinents" type="{http://www.w3.org/2001/XMLSchema}boolean"/>
 *         <element name="title" type="{http://www.w3.org/2001/XMLSchema}string" minOccurs="0"/>
 *         <element name="trace" type="{http://ssc.spdf.gsfc.nasa.gov/}trace" minOccurs="0"/>
 *       </sequence>
 *     </extension>
 *   </complexContent>
 * </complexType>
 * }</pre>
 * 
 * 
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "mapProjectionGraphOptions", propOrder = {
    "coordinateSystem",
    "formatOptions",
    "groundStations",
    "longitudeVerticalDown",
    "mapLimits",
    "polarMapOrientation",
    "projection",
    "showContinents",
    "title",
    "trace"
})
public class MapProjectionGraphOptions
    extends GraphOptions
{

    @XmlSchemaType(name = "string")
    protected ProjectionCoordinateSystem coordinateSystem;
    protected GraphFormatOptions formatOptions;
    @XmlElement(nillable = true)
    protected List<String> groundStations;
    protected float longitudeVerticalDown;
    protected MapLimits mapLimits;
    @XmlSchemaType(name = "string")
    protected PolarMapOrientation polarMapOrientation;
    @XmlSchemaType(name = "string")
    protected MapProjection projection;
    protected boolean showContinents;
    protected String title;
    @XmlSchemaType(name = "string")
    protected Trace trace;

    /**
     * Gets the value of the coordinateSystem property.
     * 
     * @return
     *     possible object is
     *     {@link ProjectionCoordinateSystem }
     *     
     */
    public ProjectionCoordinateSystem getCoordinateSystem() {
        return coordinateSystem;
    }

    /**
     * Sets the value of the coordinateSystem property.
     * 
     * @param value
     *     allowed object is
     *     {@link ProjectionCoordinateSystem }
     *     
     */
    public void setCoordinateSystem(ProjectionCoordinateSystem value) {
        this.coordinateSystem = value;
    }

    /**
     * Gets the value of the formatOptions property.
     * 
     * @return
     *     possible object is
     *     {@link GraphFormatOptions }
     *     
     */
    public GraphFormatOptions getFormatOptions() {
        return formatOptions;
    }

    /**
     * Sets the value of the formatOptions property.
     * 
     * @param value
     *     allowed object is
     *     {@link GraphFormatOptions }
     *     
     */
    public void setFormatOptions(GraphFormatOptions value) {
        this.formatOptions = value;
    }

    /**
     * Gets the value of the groundStations property.
     * 
     * <p>
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the Jakarta XML Binding object.
     * This is why there is not a {@code set} method for the groundStations property.
     * 
     * <p>
     * For example, to add a new item, do as follows:
     * <pre>
     *    getGroundStations().add(newItem);
     * </pre>
     * 
     * 
     * <p>
     * Objects of the following type(s) are allowed in the list
     * {@link String }
     * 
     * 
     * @return
     *     The value of the groundStations property.
     */
    public List<String> getGroundStations() {
        if (groundStations == null) {
            groundStations = new ArrayList<>();
        }
        return this.groundStations;
    }

    /**
     * Gets the value of the longitudeVerticalDown property.
     * 
     */
    public float getLongitudeVerticalDown() {
        return longitudeVerticalDown;
    }

    /**
     * Sets the value of the longitudeVerticalDown property.
     * 
     */
    public void setLongitudeVerticalDown(float value) {
        this.longitudeVerticalDown = value;
    }

    /**
     * Gets the value of the mapLimits property.
     * 
     * @return
     *     possible object is
     *     {@link MapLimits }
     *     
     */
    public MapLimits getMapLimits() {
        return mapLimits;
    }

    /**
     * Sets the value of the mapLimits property.
     * 
     * @param value
     *     allowed object is
     *     {@link MapLimits }
     *     
     */
    public void setMapLimits(MapLimits value) {
        this.mapLimits = value;
    }

    /**
     * Gets the value of the polarMapOrientation property.
     * 
     * @return
     *     possible object is
     *     {@link PolarMapOrientation }
     *     
     */
    public PolarMapOrientation getPolarMapOrientation() {
        return polarMapOrientation;
    }

    /**
     * Sets the value of the polarMapOrientation property.
     * 
     * @param value
     *     allowed object is
     *     {@link PolarMapOrientation }
     *     
     */
    public void setPolarMapOrientation(PolarMapOrientation value) {
        this.polarMapOrientation = value;
    }

    /**
     * Gets the value of the projection property.
     * 
     * @return
     *     possible object is
     *     {@link MapProjection }
     *     
     */
    public MapProjection getProjection() {
        return projection;
    }

    /**
     * Sets the value of the projection property.
     * 
     * @param value
     *     allowed object is
     *     {@link MapProjection }
     *     
     */
    public void setProjection(MapProjection value) {
        this.projection = value;
    }

    /**
     * Gets the value of the showContinents property.
     * 
     */
    public boolean isShowContinents() {
        return showContinents;
    }

    /**
     * Sets the value of the showContinents property.
     * 
     */
    public void setShowContinents(boolean value) {
        this.showContinents = value;
    }

    /**
     * Gets the value of the title property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getTitle() {
        return title;
    }

    /**
     * Sets the value of the title property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setTitle(String value) {
        this.title = value;
    }

    /**
     * Gets the value of the trace property.
     * 
     * @return
     *     possible object is
     *     {@link Trace }
     *     
     */
    public Trace getTrace() {
        return trace;
    }

    /**
     * Sets the value of the trace property.
     * 
     * @param value
     *     allowed object is
     *     {@link Trace }
     *     
     */
    public void setTrace(Trace value) {
        this.trace = value;
    }

}
