
package gov.nasa.gsfc.spdf.ssc.client;

import java.util.ArrayList;
import java.util.List;
import javax.xml.datatype.XMLGregorianCalendar;
import jakarta.xml.bind.annotation.XmlAccessType;
import jakarta.xml.bind.annotation.XmlAccessorType;
import jakarta.xml.bind.annotation.XmlElement;
import jakarta.xml.bind.annotation.XmlSchemaType;
import jakarta.xml.bind.annotation.XmlType;


/**
 * <p>Java class for satelliteData complex type.
 * 
 * <p>The following schema fragment specifies the expected content contained within this class.
 * 
 * <pre>{@code
 * <complexType name="satelliteData">
 *   <complexContent>
 *     <restriction base="{http://www.w3.org/2001/XMLSchema}anyType">
 *       <sequence>
 *         <element name="BGseX" type="{http://www.w3.org/2001/XMLSchema}double" maxOccurs="unbounded" minOccurs="0"/>
 *         <element name="BGseY" type="{http://www.w3.org/2001/XMLSchema}double" maxOccurs="unbounded" minOccurs="0"/>
 *         <element name="BGseZ" type="{http://www.w3.org/2001/XMLSchema}double" maxOccurs="unbounded" minOccurs="0"/>
 *         <element name="BTraceData" type="{http://ssc.spdf.gsfc.nasa.gov/}bTraceData" maxOccurs="unbounded" minOccurs="0"/>
 *         <element name="bowShockDistance" type="{http://www.w3.org/2001/XMLSchema}double" maxOccurs="unbounded" minOccurs="0"/>
 *         <element name="coordinates" type="{http://ssc.spdf.gsfc.nasa.gov/}coordinateData" maxOccurs="unbounded" minOccurs="0"/>
 *         <element name="dipoleInvariantLatitude" type="{http://www.w3.org/2001/XMLSchema}float" maxOccurs="unbounded" minOccurs="0"/>
 *         <element name="dipoleLValue" type="{http://www.w3.org/2001/XMLSchema}double" maxOccurs="unbounded" minOccurs="0"/>
 *         <element name="id" type="{http://www.w3.org/2001/XMLSchema}string" minOccurs="0"/>
 *         <element name="magneticStrength" type="{http://www.w3.org/2001/XMLSchema}double" maxOccurs="unbounded" minOccurs="0"/>
 *         <element name="magnetoPauseDistance" type="{http://www.w3.org/2001/XMLSchema}double" maxOccurs="unbounded" minOccurs="0"/>
 *         <element name="neutralSheetDistance" type="{http://www.w3.org/2001/XMLSchema}double" maxOccurs="unbounded" minOccurs="0"/>
 *         <element name="northBTracedRegions" type="{http://ssc.spdf.gsfc.nasa.gov/}footpointRegion" maxOccurs="unbounded" minOccurs="0"/>
 *         <element name="radialLength" type="{http://www.w3.org/2001/XMLSchema}double" maxOccurs="unbounded" minOccurs="0"/>
 *         <element name="radialTraceFootpointRegion" type="{http://ssc.spdf.gsfc.nasa.gov/}footpointRegion" maxOccurs="unbounded" minOccurs="0"/>
 *         <element name="southBTracedRegions" type="{http://ssc.spdf.gsfc.nasa.gov/}footpointRegion" maxOccurs="unbounded" minOccurs="0"/>
 *         <element name="spacecraftRegion" type="{http://ssc.spdf.gsfc.nasa.gov/}spaceRegion" maxOccurs="unbounded" minOccurs="0"/>
 *         <element name="time" type="{http://www.w3.org/2001/XMLSchema}dateTime" maxOccurs="unbounded" minOccurs="0"/>
 *       </sequence>
 *     </restriction>
 *   </complexContent>
 * </complexType>
 * }</pre>
 * 
 * 
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "satelliteData", propOrder = {
    "bGseX",
    "bGseY",
    "bGseZ",
    "bTraceData",
    "bowShockDistance",
    "coordinates",
    "dipoleInvariantLatitude",
    "dipoleLValue",
    "id",
    "magneticStrength",
    "magnetoPauseDistance",
    "neutralSheetDistance",
    "northBTracedRegions",
    "radialLength",
    "radialTraceFootpointRegion",
    "southBTracedRegions",
    "spacecraftRegion",
    "time"
})
public class SatelliteData {

    @XmlElement(name = "BGseX", nillable = true)
    protected List<Double> bGseX;
    @XmlElement(name = "BGseY", nillable = true)
    protected List<Double> bGseY;
    @XmlElement(name = "BGseZ", nillable = true)
    protected List<Double> bGseZ;
    @XmlElement(name = "BTraceData", nillable = true)
    protected List<BTraceData> bTraceData;
    @XmlElement(nillable = true)
    protected List<Double> bowShockDistance;
    @XmlElement(nillable = true)
    protected List<CoordinateData> coordinates;
    @XmlElement(nillable = true)
    protected List<Float> dipoleInvariantLatitude;
    @XmlElement(nillable = true)
    protected List<Double> dipoleLValue;
    protected String id;
    @XmlElement(nillable = true)
    protected List<Double> magneticStrength;
    @XmlElement(nillable = true)
    protected List<Double> magnetoPauseDistance;
    @XmlElement(nillable = true)
    protected List<Double> neutralSheetDistance;
    @XmlElement(nillable = true)
    @XmlSchemaType(name = "string")
    protected List<FootpointRegion> northBTracedRegions;
    @XmlElement(nillable = true)
    protected List<Double> radialLength;
    @XmlElement(nillable = true)
    @XmlSchemaType(name = "string")
    protected List<FootpointRegion> radialTraceFootpointRegion;
    @XmlElement(nillable = true)
    @XmlSchemaType(name = "string")
    protected List<FootpointRegion> southBTracedRegions;
    @XmlElement(nillable = true)
    @XmlSchemaType(name = "string")
    protected List<SpaceRegion> spacecraftRegion;
    @XmlElement(nillable = true)
    @XmlSchemaType(name = "dateTime")
    protected List<XMLGregorianCalendar> time;

    /**
     * Gets the value of the bGseX property.
     * 
     * <p>
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the Jakarta XML Binding object.
     * This is why there is not a {@code set} method for the bGseX property.
     * 
     * <p>
     * For example, to add a new item, do as follows:
     * <pre>
     *    getBGseX().add(newItem);
     * </pre>
     * 
     * 
     * <p>
     * Objects of the following type(s) are allowed in the list
     * {@link Double }
     * 
     * 
     * @return
     *     The value of the bGseX property.
     */
    public List<Double> getBGseX() {
        if (bGseX == null) {
            bGseX = new ArrayList<>();
        }
        return this.bGseX;
    }

    /**
     * Gets the value of the bGseY property.
     * 
     * <p>
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the Jakarta XML Binding object.
     * This is why there is not a {@code set} method for the bGseY property.
     * 
     * <p>
     * For example, to add a new item, do as follows:
     * <pre>
     *    getBGseY().add(newItem);
     * </pre>
     * 
     * 
     * <p>
     * Objects of the following type(s) are allowed in the list
     * {@link Double }
     * 
     * 
     * @return
     *     The value of the bGseY property.
     */
    public List<Double> getBGseY() {
        if (bGseY == null) {
            bGseY = new ArrayList<>();
        }
        return this.bGseY;
    }

    /**
     * Gets the value of the bGseZ property.
     * 
     * <p>
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the Jakarta XML Binding object.
     * This is why there is not a {@code set} method for the bGseZ property.
     * 
     * <p>
     * For example, to add a new item, do as follows:
     * <pre>
     *    getBGseZ().add(newItem);
     * </pre>
     * 
     * 
     * <p>
     * Objects of the following type(s) are allowed in the list
     * {@link Double }
     * 
     * 
     * @return
     *     The value of the bGseZ property.
     */
    public List<Double> getBGseZ() {
        if (bGseZ == null) {
            bGseZ = new ArrayList<>();
        }
        return this.bGseZ;
    }

    /**
     * Gets the value of the bTraceData property.
     * 
     * <p>
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the Jakarta XML Binding object.
     * This is why there is not a {@code set} method for the bTraceData property.
     * 
     * <p>
     * For example, to add a new item, do as follows:
     * <pre>
     *    getBTraceData().add(newItem);
     * </pre>
     * 
     * 
     * <p>
     * Objects of the following type(s) are allowed in the list
     * {@link BTraceData }
     * 
     * 
     * @return
     *     The value of the bTraceData property.
     */
    public List<BTraceData> getBTraceData() {
        if (bTraceData == null) {
            bTraceData = new ArrayList<>();
        }
        return this.bTraceData;
    }

    /**
     * Gets the value of the bowShockDistance property.
     * 
     * <p>
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the Jakarta XML Binding object.
     * This is why there is not a {@code set} method for the bowShockDistance property.
     * 
     * <p>
     * For example, to add a new item, do as follows:
     * <pre>
     *    getBowShockDistance().add(newItem);
     * </pre>
     * 
     * 
     * <p>
     * Objects of the following type(s) are allowed in the list
     * {@link Double }
     * 
     * 
     * @return
     *     The value of the bowShockDistance property.
     */
    public List<Double> getBowShockDistance() {
        if (bowShockDistance == null) {
            bowShockDistance = new ArrayList<>();
        }
        return this.bowShockDistance;
    }

    /**
     * Gets the value of the coordinates property.
     * 
     * <p>
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the Jakarta XML Binding object.
     * This is why there is not a {@code set} method for the coordinates property.
     * 
     * <p>
     * For example, to add a new item, do as follows:
     * <pre>
     *    getCoordinates().add(newItem);
     * </pre>
     * 
     * 
     * <p>
     * Objects of the following type(s) are allowed in the list
     * {@link CoordinateData }
     * 
     * 
     * @return
     *     The value of the coordinates property.
     */
    public List<CoordinateData> getCoordinates() {
        if (coordinates == null) {
            coordinates = new ArrayList<>();
        }
        return this.coordinates;
    }

    /**
     * Gets the value of the dipoleInvariantLatitude property.
     * 
     * <p>
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the Jakarta XML Binding object.
     * This is why there is not a {@code set} method for the dipoleInvariantLatitude property.
     * 
     * <p>
     * For example, to add a new item, do as follows:
     * <pre>
     *    getDipoleInvariantLatitude().add(newItem);
     * </pre>
     * 
     * 
     * <p>
     * Objects of the following type(s) are allowed in the list
     * {@link Float }
     * 
     * 
     * @return
     *     The value of the dipoleInvariantLatitude property.
     */
    public List<Float> getDipoleInvariantLatitude() {
        if (dipoleInvariantLatitude == null) {
            dipoleInvariantLatitude = new ArrayList<>();
        }
        return this.dipoleInvariantLatitude;
    }

    /**
     * Gets the value of the dipoleLValue property.
     * 
     * <p>
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the Jakarta XML Binding object.
     * This is why there is not a {@code set} method for the dipoleLValue property.
     * 
     * <p>
     * For example, to add a new item, do as follows:
     * <pre>
     *    getDipoleLValue().add(newItem);
     * </pre>
     * 
     * 
     * <p>
     * Objects of the following type(s) are allowed in the list
     * {@link Double }
     * 
     * 
     * @return
     *     The value of the dipoleLValue property.
     */
    public List<Double> getDipoleLValue() {
        if (dipoleLValue == null) {
            dipoleLValue = new ArrayList<>();
        }
        return this.dipoleLValue;
    }

    /**
     * Gets the value of the id property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getId() {
        return id;
    }

    /**
     * Sets the value of the id property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setId(String value) {
        this.id = value;
    }

    /**
     * Gets the value of the magneticStrength property.
     * 
     * <p>
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the Jakarta XML Binding object.
     * This is why there is not a {@code set} method for the magneticStrength property.
     * 
     * <p>
     * For example, to add a new item, do as follows:
     * <pre>
     *    getMagneticStrength().add(newItem);
     * </pre>
     * 
     * 
     * <p>
     * Objects of the following type(s) are allowed in the list
     * {@link Double }
     * 
     * 
     * @return
     *     The value of the magneticStrength property.
     */
    public List<Double> getMagneticStrength() {
        if (magneticStrength == null) {
            magneticStrength = new ArrayList<>();
        }
        return this.magneticStrength;
    }

    /**
     * Gets the value of the magnetoPauseDistance property.
     * 
     * <p>
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the Jakarta XML Binding object.
     * This is why there is not a {@code set} method for the magnetoPauseDistance property.
     * 
     * <p>
     * For example, to add a new item, do as follows:
     * <pre>
     *    getMagnetoPauseDistance().add(newItem);
     * </pre>
     * 
     * 
     * <p>
     * Objects of the following type(s) are allowed in the list
     * {@link Double }
     * 
     * 
     * @return
     *     The value of the magnetoPauseDistance property.
     */
    public List<Double> getMagnetoPauseDistance() {
        if (magnetoPauseDistance == null) {
            magnetoPauseDistance = new ArrayList<>();
        }
        return this.magnetoPauseDistance;
    }

    /**
     * Gets the value of the neutralSheetDistance property.
     * 
     * <p>
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the Jakarta XML Binding object.
     * This is why there is not a {@code set} method for the neutralSheetDistance property.
     * 
     * <p>
     * For example, to add a new item, do as follows:
     * <pre>
     *    getNeutralSheetDistance().add(newItem);
     * </pre>
     * 
     * 
     * <p>
     * Objects of the following type(s) are allowed in the list
     * {@link Double }
     * 
     * 
     * @return
     *     The value of the neutralSheetDistance property.
     */
    public List<Double> getNeutralSheetDistance() {
        if (neutralSheetDistance == null) {
            neutralSheetDistance = new ArrayList<>();
        }
        return this.neutralSheetDistance;
    }

    /**
     * Gets the value of the northBTracedRegions property.
     * 
     * <p>
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the Jakarta XML Binding object.
     * This is why there is not a {@code set} method for the northBTracedRegions property.
     * 
     * <p>
     * For example, to add a new item, do as follows:
     * <pre>
     *    getNorthBTracedRegions().add(newItem);
     * </pre>
     * 
     * 
     * <p>
     * Objects of the following type(s) are allowed in the list
     * {@link FootpointRegion }
     * 
     * 
     * @return
     *     The value of the northBTracedRegions property.
     */
    public List<FootpointRegion> getNorthBTracedRegions() {
        if (northBTracedRegions == null) {
            northBTracedRegions = new ArrayList<>();
        }
        return this.northBTracedRegions;
    }

    /**
     * Gets the value of the radialLength property.
     * 
     * <p>
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the Jakarta XML Binding object.
     * This is why there is not a {@code set} method for the radialLength property.
     * 
     * <p>
     * For example, to add a new item, do as follows:
     * <pre>
     *    getRadialLength().add(newItem);
     * </pre>
     * 
     * 
     * <p>
     * Objects of the following type(s) are allowed in the list
     * {@link Double }
     * 
     * 
     * @return
     *     The value of the radialLength property.
     */
    public List<Double> getRadialLength() {
        if (radialLength == null) {
            radialLength = new ArrayList<>();
        }
        return this.radialLength;
    }

    /**
     * Gets the value of the radialTraceFootpointRegion property.
     * 
     * <p>
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the Jakarta XML Binding object.
     * This is why there is not a {@code set} method for the radialTraceFootpointRegion property.
     * 
     * <p>
     * For example, to add a new item, do as follows:
     * <pre>
     *    getRadialTraceFootpointRegion().add(newItem);
     * </pre>
     * 
     * 
     * <p>
     * Objects of the following type(s) are allowed in the list
     * {@link FootpointRegion }
     * 
     * 
     * @return
     *     The value of the radialTraceFootpointRegion property.
     */
    public List<FootpointRegion> getRadialTraceFootpointRegion() {
        if (radialTraceFootpointRegion == null) {
            radialTraceFootpointRegion = new ArrayList<>();
        }
        return this.radialTraceFootpointRegion;
    }

    /**
     * Gets the value of the southBTracedRegions property.
     * 
     * <p>
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the Jakarta XML Binding object.
     * This is why there is not a {@code set} method for the southBTracedRegions property.
     * 
     * <p>
     * For example, to add a new item, do as follows:
     * <pre>
     *    getSouthBTracedRegions().add(newItem);
     * </pre>
     * 
     * 
     * <p>
     * Objects of the following type(s) are allowed in the list
     * {@link FootpointRegion }
     * 
     * 
     * @return
     *     The value of the southBTracedRegions property.
     */
    public List<FootpointRegion> getSouthBTracedRegions() {
        if (southBTracedRegions == null) {
            southBTracedRegions = new ArrayList<>();
        }
        return this.southBTracedRegions;
    }

    /**
     * Gets the value of the spacecraftRegion property.
     * 
     * <p>
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the Jakarta XML Binding object.
     * This is why there is not a {@code set} method for the spacecraftRegion property.
     * 
     * <p>
     * For example, to add a new item, do as follows:
     * <pre>
     *    getSpacecraftRegion().add(newItem);
     * </pre>
     * 
     * 
     * <p>
     * Objects of the following type(s) are allowed in the list
     * {@link SpaceRegion }
     * 
     * 
     * @return
     *     The value of the spacecraftRegion property.
     */
    public List<SpaceRegion> getSpacecraftRegion() {
        if (spacecraftRegion == null) {
            spacecraftRegion = new ArrayList<>();
        }
        return this.spacecraftRegion;
    }

    /**
     * Gets the value of the time property.
     * 
     * <p>
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the Jakarta XML Binding object.
     * This is why there is not a {@code set} method for the time property.
     * 
     * <p>
     * For example, to add a new item, do as follows:
     * <pre>
     *    getTime().add(newItem);
     * </pre>
     * 
     * 
     * <p>
     * Objects of the following type(s) are allowed in the list
     * {@link XMLGregorianCalendar }
     * 
     * 
     * @return
     *     The value of the time property.
     */
    public List<XMLGregorianCalendar> getTime() {
        if (time == null) {
            time = new ArrayList<>();
        }
        return this.time;
    }

}
