
package gov.nasa.gsfc.spdf.ssc.client;

import jakarta.xml.bind.annotation.XmlEnum;
import jakarta.xml.bind.annotation.XmlType;


/**
 * <p>Java class for spaceRegion.
 * 
 * <p>The following schema fragment specifies the expected content contained within this class.
 * <pre>{@code
 * <simpleType name="spaceRegion">
 *   <restriction base="{http://www.w3.org/2001/XMLSchema}string">
 *     <enumeration value="INTERPLANETARY_MEDIUM"/>
 *     <enumeration value="DAYSIDE_MAGNETOSHEATH"/>
 *     <enumeration value="NIGHTSIDE_MAGNETOSHEATH"/>
 *     <enumeration value="DAYSIDE_MAGNETOSPHERE"/>
 *     <enumeration value="NIGHTSIDE_MAGNETOSPHERE"/>
 *     <enumeration value="PLASMA_SHEET"/>
 *     <enumeration value="TAIL_LOBE"/>
 *     <enumeration value="LOW_LATITUDE_BOUNDARY_LAYER"/>
 *     <enumeration value="HIGH_LATITUDE_BOUNDARY_LAYER"/>
 *     <enumeration value="DAYSIDE_PLASMASPHERE"/>
 *     <enumeration value="NIGHTSIDE_PLASMASPHERE"/>
 *   </restriction>
 * </simpleType>
 * }</pre>
 * 
 */
@XmlType(name = "spaceRegion")
@XmlEnum
public enum SpaceRegion {

    INTERPLANETARY_MEDIUM,
    DAYSIDE_MAGNETOSHEATH,
    NIGHTSIDE_MAGNETOSHEATH,
    DAYSIDE_MAGNETOSPHERE,
    NIGHTSIDE_MAGNETOSPHERE,
    PLASMA_SHEET,
    TAIL_LOBE,
    LOW_LATITUDE_BOUNDARY_LAYER,
    HIGH_LATITUDE_BOUNDARY_LAYER,
    DAYSIDE_PLASMASPHERE,
    NIGHTSIDE_PLASMASPHERE;

    public String value() {
        return name();
    }

    public static SpaceRegion fromValue(String v) {
        return valueOf(v);
    }

}
